<?php
/**
* @version 1.0.0
* @package RSSearch! 1.0.0
* @copyright (C) 2011 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.plugin');
 
class plgRSSearchRSMembership extends JPlugin
{
	public function __construct( &$subject, $config ) {
		parent::__construct( $subject, $config );
	}
	
	public function getResults(&$results, $search, $params) {
		$db			= JFactory::getDBO();
	    $fields		= (array) $this->params->get('searchfields','');
	    $orderby 	= $this->params->get('orderby','name');
	    $asc_desc 	= $this->params->get('asc_desc','ASC');
		$categories = (array) $this->params->get('rsmcategories','');
	    $itemId 	= $this->params->get('Itemid','');
	    $itemId 	= (empty($itemId) ? '' : '&Itemid='.$itemId);

		JFactory::getLanguage()->load('plg_rssearch_rsmembership',JPATH_ADMINISTRATOR);

		require_once JPATH_ADMINISTRATOR . '/components/com_search/helpers/search.php';
		
		foreach($fields as $field) {
			if ($field == 'rsmembership_memberships') {
				$where_catid = '';
				if (in_array('rsmembership_categories', $fields)) {
					if (!in_array('', $categories)) {
						JArrayHelper::toInteger($categories);
						$where_catid = ' AND '.$db->qn('c.category_id').' IN ('.implode(',', $categories).') ';
					}
				}
				
				$query = 'SELECT DISTINCT '.$db->qn('m.id').', '.$db->qn('m.name').', '.$db->qn('m.description').', '.$db->qn('m.category_id').', '.$db->qn('c.name','category_name').' FROM '.$db->qn('#__rsmembership_memberships','m').' LEFT JOIN '.$db->qn('#__rsmembership_categories','c').' ON '.$db->qn('m.category_id').' = '.$db->qn('c.id').' WHERE ('.$db->qn('m.name').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('m.description').' LIKE '.$db->q('%'.$search.'%').') AND '.$db->qn('m.published').' = 1 '.$where_catid.' ORDER BY '.$db->qn('m.'.$orderby).' '.$db->escape($asc_desc);

				$db->setQuery($query);
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) {
						if ( !searchHelper::checkNoHTML($item, $search, array('name', 'description')) ) continue;

						$tmp		= new stdClass();
						$tmp->title = $item->name;
						$tmp->link 	= JRoute::_('index.php?option=com_rsmembership&view=membership&catid='.$item->category_id.':'.JFilterOutput::stringURLSafe($item->category_name).'&cid='.$item->id.':'.JFilterOutput::stringURLSafe($item->name).$itemId);
						$tmp->text 	= $item->description;
						$tmp->type 	= JText::_('RSF_RSM_XML_MEMBERSHIP');
						$results[] 	= $tmp;
					}
				}
				
			} elseif($field == 'rsmembership_categories') {
				$where_catid = '';
				
				if (!in_array('', $categories)) {
					JArrayHelper::toInteger($categories);
					$where_catid = ' AND '.$db->qn('id').' IN ('.implode(',', $categories).') ';
				}
				
				$query = 'SELECT DISTINCT '.$db->qn('id').', '.$db->qn('name').', '.$db->qn('description').' FROM '.$db->qn('#__rsmembership_categories').' WHERE '.$db->qn('name').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('description').' LIKE '.$db->q('%'.$search.'%').' AND '.$db->qn('published').' = 1 ORDER BY '.$db->qn($orderby).' '.$db->escape($asc_desc);

				$db->setQuery($query);
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) {
						if ( !searchHelper::checkNoHTML($item, $search, array('name', 'description')) ) continue;

						$tmp		= new stdClass();
						$tmp->title = $item->name;
						$tmp->link 	= JRoute::_('index.php?option=com_rsmembership&view=rsmembership&layout=list&catid='.$item->id.':'.JFilterOutput::stringURLSafe($item->name).$itemId);
						$tmp->text 	= $item->description;
						$tmp->type 	= JText::_('RSF_RSM_XML_CATEGORY');
						$results[] 	= $tmp;
					}
				}
			}
		}
	    return true;
	}
}